git-commit.shon commit Merge branch 'jc/reflog' into lj/refs (2e6d8f1)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Linus Torvalds
   4# Copyright (c) 2006 Junio C Hamano
   5
   6USAGE='[-a] [-s] [-v] [--no-verify] [-m <message> | -F <logfile> | (-C|-c) <commit>] [-u] [--amend] [-e] [--author <author>] [[-i | -o] <path>...]'
   7SUBDIRECTORY_OK=Yes
   8. git-sh-setup
   9
  10git-rev-parse --verify HEAD >/dev/null 2>&1 || initial_commit=t
  11branch=$(GIT_DIR="$GIT_DIR" git-symbolic-ref HEAD)
  12
  13case "$0" in
  14*status)
  15        status_only=t
  16        unmerged_ok_if_status=--unmerged ;;
  17*commit)
  18        status_only=
  19        unmerged_ok_if_status= ;;
  20esac
  21
  22refuse_partial () {
  23        echo >&2 "$1"
  24        echo >&2 "You might have meant to say 'git commit -i paths...', perhaps?"
  25        exit 1
  26}
  27
  28THIS_INDEX="$GIT_DIR/index"
  29NEXT_INDEX="$GIT_DIR/next-index$$"
  30rm -f "$NEXT_INDEX"
  31save_index () {
  32        cp -p "$THIS_INDEX" "$NEXT_INDEX"
  33}
  34
  35report () {
  36  header="#
  37# $1:
  38#   ($2)
  39#
  40"
  41  trailer=""
  42  while read status name newname
  43  do
  44    printf '%s' "$header"
  45    header=""
  46    trailer="#
  47"
  48    case "$status" in
  49    M ) echo "# modified: $name";;
  50    D*) echo "# deleted:  $name";;
  51    T ) echo "# typechange: $name";;
  52    C*) echo "# copied: $name -> $newname";;
  53    R*) echo "# renamed: $name -> $newname";;
  54    A*) echo "# new file: $name";;
  55    U ) echo "# unmerged: $name";;
  56    esac
  57  done
  58  printf '%s' "$trailer"
  59  [ "$header" ]
  60}
  61
  62run_status () {
  63        # If TMP_INDEX is defined, that means we are doing
  64        # "--only" partial commit, and that index file is used
  65        # to build the tree for the commit.  Otherwise, if
  66        # NEXT_INDEX exists, that is the index file used to
  67        # make the commit.  Otherwise we are using as-is commit
  68        # so the regular index file is what we use to compare.
  69        if test '' != "$TMP_INDEX"
  70        then
  71            GIT_INDEX_FILE="$TMP_INDEX"
  72            export GIT_INDEX_FILE
  73        elif test -f "$NEXT_INDEX"
  74        then
  75            GIT_INDEX_FILE="$NEXT_INDEX"
  76            export GIT_INDEX_FILE
  77        fi
  78
  79  case "$status_only" in
  80    t) color= ;;
  81    *) color=--nocolor ;;
  82  esac
  83  git-runstatus ${color} \
  84                ${verbose:+--verbose} \
  85                ${amend:+--amend} \
  86                ${untracked_files:+--untracked}
  87}
  88
  89trap '
  90        test -z "$TMP_INDEX" || {
  91                test -f "$TMP_INDEX" && rm -f "$TMP_INDEX"
  92        }
  93        rm -f "$NEXT_INDEX"
  94' 0
  95
  96################################################################
  97# Command line argument parsing and sanity checking
  98
  99all=
 100also=
 101only=
 102logfile=
 103use_commit=
 104amend=
 105edit_flag=
 106no_edit=
 107log_given=
 108log_message=
 109verify=t
 110verbose=
 111signoff=
 112force_author=
 113only_include_assumed=
 114untracked_files=
 115while case "$#" in 0) break;; esac
 116do
 117  case "$1" in
 118  -F|--F|-f|--f|--fi|--fil|--file)
 119      case "$#" in 1) usage ;; esac
 120      shift
 121      no_edit=t
 122      log_given=t$log_given
 123      logfile="$1"
 124      shift
 125      ;;
 126  -F*|-f*)
 127      no_edit=t
 128      log_given=t$log_given
 129      logfile=`expr "z$1" : 'z-[Ff]\(.*\)'`
 130      shift
 131      ;;
 132  --F=*|--f=*|--fi=*|--fil=*|--file=*)
 133      no_edit=t
 134      log_given=t$log_given
 135      logfile=`expr "z$1" : 'z-[^=]*=\(.*\)'`
 136      shift
 137      ;;
 138  -a|--a|--al|--all)
 139      all=t
 140      shift
 141      ;;
 142  --au=*|--aut=*|--auth=*|--autho=*|--author=*)
 143      force_author=`expr "z$1" : 'z-[^=]*=\(.*\)'`
 144      shift
 145      ;;
 146  --au|--aut|--auth|--autho|--author)
 147      case "$#" in 1) usage ;; esac
 148      shift
 149      force_author="$1"
 150      shift
 151      ;;
 152  -e|--e|--ed|--edi|--edit)
 153      edit_flag=t
 154      shift
 155      ;;
 156  -i|--i|--in|--inc|--incl|--inclu|--includ|--include)
 157      also=t
 158      shift
 159      ;;
 160  -o|--o|--on|--onl|--only)
 161      only=t
 162      shift
 163      ;;
 164  -m|--m|--me|--mes|--mess|--messa|--messag|--message)
 165      case "$#" in 1) usage ;; esac
 166      shift
 167      log_given=m$log_given
 168      if test "$log_message" = ''
 169      then
 170          log_message="$1"
 171      else
 172          log_message="$log_message
 173
 174$1"
 175      fi
 176      no_edit=t
 177      shift
 178      ;;
 179  -m*)
 180      log_given=m$log_given
 181      if test "$log_message" = ''
 182      then
 183          log_message=`expr "z$1" : 'z-m\(.*\)'`
 184      else
 185          log_message="$log_message
 186
 187`expr "z$1" : 'z-m\(.*\)'`"
 188      fi
 189      no_edit=t
 190      shift
 191      ;;
 192  --m=*|--me=*|--mes=*|--mess=*|--messa=*|--messag=*|--message=*)
 193      log_given=m$log_given
 194      if test "$log_message" = ''
 195      then
 196          log_message=`expr "z$1" : 'z-[^=]*=\(.*\)'`
 197      else
 198          log_message="$log_message
 199
 200`expr "z$1" : 'zq-[^=]*=\(.*\)'`"
 201      fi
 202      no_edit=t
 203      shift
 204      ;;
 205  -n|--n|--no|--no-|--no-v|--no-ve|--no-ver|--no-veri|--no-verif|--no-verify)
 206      verify=
 207      shift
 208      ;;
 209  --a|--am|--ame|--amen|--amend)
 210      amend=t
 211      log_given=t$log_given
 212      use_commit=HEAD
 213      shift
 214      ;;
 215  -c)
 216      case "$#" in 1) usage ;; esac
 217      shift
 218      log_given=t$log_given
 219      use_commit="$1"
 220      no_edit=
 221      shift
 222      ;;
 223  --ree=*|--reed=*|--reedi=*|--reedit=*|--reedit-=*|--reedit-m=*|\
 224  --reedit-me=*|--reedit-mes=*|--reedit-mess=*|--reedit-messa=*|\
 225  --reedit-messag=*|--reedit-message=*)
 226      log_given=t$log_given
 227      use_commit=`expr "z$1" : 'z-[^=]*=\(.*\)'`
 228      no_edit=
 229      shift
 230      ;;
 231  --ree|--reed|--reedi|--reedit|--reedit-|--reedit-m|--reedit-me|\
 232  --reedit-mes|--reedit-mess|--reedit-messa|--reedit-messag|--reedit-message)
 233      case "$#" in 1) usage ;; esac
 234      shift
 235      log_given=t$log_given
 236      use_commit="$1"
 237      no_edit=
 238      shift
 239      ;;
 240  -C)
 241      case "$#" in 1) usage ;; esac
 242      shift
 243      log_given=t$log_given
 244      use_commit="$1"
 245      no_edit=t
 246      shift
 247      ;;
 248  --reu=*|--reus=*|--reuse=*|--reuse-=*|--reuse-m=*|--reuse-me=*|\
 249  --reuse-mes=*|--reuse-mess=*|--reuse-messa=*|--reuse-messag=*|\
 250  --reuse-message=*)
 251      log_given=t$log_given
 252      use_commit=`expr "z$1" : 'z-[^=]*=\(.*\)'`
 253      no_edit=t
 254      shift
 255      ;;
 256  --reu|--reus|--reuse|--reuse-|--reuse-m|--reuse-me|--reuse-mes|\
 257  --reuse-mess|--reuse-messa|--reuse-messag|--reuse-message)
 258      case "$#" in 1) usage ;; esac
 259      shift
 260      log_given=t$log_given
 261      use_commit="$1"
 262      no_edit=t
 263      shift
 264      ;;
 265  -s|--s|--si|--sig|--sign|--signo|--signof|--signoff)
 266      signoff=t
 267      shift
 268      ;;
 269  -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
 270      verbose=t
 271      shift
 272      ;;
 273  -u|--u|--un|--unt|--untr|--untra|--untrac|--untrack|--untracke|--untracked|\
 274  --untracked-|--untracked-f|--untracked-fi|--untracked-fil|--untracked-file|\
 275  --untracked-files)
 276      untracked_files=t
 277      shift
 278      ;;
 279  --)
 280      shift
 281      break
 282      ;;
 283  -*)
 284      usage
 285      ;;
 286  *)
 287      break
 288      ;;
 289  esac
 290done
 291case "$edit_flag" in t) no_edit= ;; esac
 292
 293################################################################
 294# Sanity check options
 295
 296case "$amend,$initial_commit" in
 297t,t)
 298  die "You do not have anything to amend." ;;
 299t,)
 300  if [ -f "$GIT_DIR/MERGE_HEAD" ]; then
 301    die "You are in the middle of a merge -- cannot amend."
 302  fi ;;
 303esac
 304
 305case "$log_given" in
 306tt*)
 307  die "Only one of -c/-C/-F can be used." ;;
 308*tm*|*mt*)
 309  die "Option -m cannot be combined with -c/-C/-F." ;;
 310esac
 311
 312case "$#,$also,$only,$amend" in
 313*,t,t,*)
 314  die "Only one of --include/--only can be used." ;;
 3150,t,,* | 0,,t,)
 316  die "No paths with --include/--only does not make sense." ;;
 3170,,t,t)
 318  only_include_assumed="# Clever... amending the last one with dirty index." ;;
 3190,,,*)
 320  ;;
 321*,,,*)
 322  only_include_assumed="# Explicit paths specified without -i nor -o; assuming --only paths..."
 323  also=
 324  ;;
 325esac
 326unset only
 327case "$all,$also,$#" in
 328t,t,*)
 329        die "Cannot use -a and -i at the same time." ;;
 330t,,[1-9]*)
 331        die "Paths with -a does not make sense." ;;
 332,t,0)
 333        die "No paths with -i does not make sense." ;;
 334esac
 335
 336################################################################
 337# Prepare index to have a tree to be committed
 338
 339TOP=`git-rev-parse --show-cdup`
 340if test -z "$TOP"
 341then
 342        TOP=./
 343fi
 344
 345case "$all,$also" in
 346t,)
 347        save_index &&
 348        (
 349                cd "$TOP"
 350                GIT_INDEX_FILE="$NEXT_INDEX"
 351                export GIT_INDEX_FILE
 352                git-diff-files --name-only -z |
 353                git-update-index --remove -z --stdin
 354        )
 355        ;;
 356,t)
 357        save_index &&
 358        git-ls-files --error-unmatch -- "$@" >/dev/null || exit
 359
 360        git-diff-files --name-only -z -- "$@"  |
 361        (
 362                cd "$TOP"
 363                GIT_INDEX_FILE="$NEXT_INDEX"
 364                export GIT_INDEX_FILE
 365                git-update-index --remove -z --stdin
 366        )
 367        ;;
 368,)
 369        case "$#" in
 370        0)
 371            ;; # commit as-is
 372        *)
 373            if test -f "$GIT_DIR/MERGE_HEAD"
 374            then
 375                refuse_partial "Cannot do a partial commit during a merge."
 376            fi
 377            TMP_INDEX="$GIT_DIR/tmp-index$$"
 378            if test -z "$initial_commit"
 379            then
 380                # make sure index is clean at the specified paths, or
 381                # they are additions.
 382                dirty_in_index=`git-diff-index --cached --name-status \
 383                        --diff-filter=DMTU HEAD -- "$@"`
 384                test -z "$dirty_in_index" ||
 385                refuse_partial "Different in index and the last commit:
 386$dirty_in_index"
 387            fi
 388            commit_only=`git-ls-files --error-unmatch -- "$@"` || exit
 389
 390            # Build the temporary index and update the real index
 391            # the same way.
 392            if test -z "$initial_commit"
 393            then
 394                cp "$THIS_INDEX" "$TMP_INDEX"
 395                GIT_INDEX_FILE="$TMP_INDEX" git-read-tree -m HEAD
 396            else
 397                    rm -f "$TMP_INDEX"
 398            fi || exit
 399
 400            echo "$commit_only" |
 401            GIT_INDEX_FILE="$TMP_INDEX" \
 402            git-update-index --add --remove --stdin &&
 403
 404            save_index &&
 405            echo "$commit_only" |
 406            (
 407                GIT_INDEX_FILE="$NEXT_INDEX"
 408                export GIT_INDEX_FILE
 409                git-update-index --remove --stdin
 410            ) || exit
 411            ;;
 412        esac
 413        ;;
 414esac
 415
 416################################################################
 417# If we do as-is commit, the index file will be THIS_INDEX,
 418# otherwise NEXT_INDEX after we make this commit.  We leave
 419# the index as is if we abort.
 420
 421if test -f "$NEXT_INDEX"
 422then
 423        USE_INDEX="$NEXT_INDEX"
 424else
 425        USE_INDEX="$THIS_INDEX"
 426fi
 427
 428GIT_INDEX_FILE="$USE_INDEX" \
 429    git-update-index -q $unmerged_ok_if_status --refresh || exit
 430
 431################################################################
 432# If the request is status, just show it and exit.
 433
 434case "$0" in
 435*status)
 436        run_status
 437        exit $?
 438esac
 439
 440################################################################
 441# Grab commit message, write out tree and make commit.
 442
 443if test t = "$verify" && test -x "$GIT_DIR"/hooks/pre-commit
 444then
 445        if test "$TMP_INDEX"
 446        then
 447                GIT_INDEX_FILE="$TMP_INDEX" "$GIT_DIR"/hooks/pre-commit
 448        else
 449                GIT_INDEX_FILE="$USE_INDEX" "$GIT_DIR"/hooks/pre-commit
 450        fi || exit
 451fi
 452
 453if test "$log_message" != ''
 454then
 455        echo "$log_message"
 456elif test "$logfile" != ""
 457then
 458        if test "$logfile" = -
 459        then
 460                test -t 0 &&
 461                echo >&2 "(reading log message from standard input)"
 462                cat
 463        else
 464                cat <"$logfile"
 465        fi
 466elif test "$use_commit" != ""
 467then
 468        git-cat-file commit "$use_commit" | sed -e '1,/^$/d'
 469elif test -f "$GIT_DIR/MERGE_MSG"
 470then
 471        cat "$GIT_DIR/MERGE_MSG"
 472elif test -f "$GIT_DIR/SQUASH_MSG"
 473then
 474        cat "$GIT_DIR/SQUASH_MSG"
 475fi | git-stripspace >"$GIT_DIR"/COMMIT_EDITMSG
 476
 477case "$signoff" in
 478t)
 479        {
 480                echo
 481                git-var GIT_COMMITTER_IDENT | sed -e '
 482                        s/>.*/>/
 483                        s/^/Signed-off-by: /
 484                '
 485        } >>"$GIT_DIR"/COMMIT_EDITMSG
 486        ;;
 487esac
 488
 489if test -f "$GIT_DIR/MERGE_HEAD" && test -z "$no_edit"; then
 490        echo "#"
 491        echo "# It looks like you may be committing a MERGE."
 492        echo "# If this is not correct, please remove the file"
 493        echo "# $GIT_DIR/MERGE_HEAD"
 494        echo "# and try again"
 495        echo "#"
 496fi >>"$GIT_DIR"/COMMIT_EDITMSG
 497
 498# Author
 499if test '' != "$force_author"
 500then
 501        GIT_AUTHOR_NAME=`expr "z$force_author" : 'z\(.*[^ ]\) *<.*'` &&
 502        GIT_AUTHOR_EMAIL=`expr "z$force_author" : '.*\(<.*\)'` &&
 503        test '' != "$GIT_AUTHOR_NAME" &&
 504        test '' != "$GIT_AUTHOR_EMAIL" ||
 505        die "malformed --author parameter"
 506        export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL
 507elif test '' != "$use_commit"
 508then
 509        pick_author_script='
 510        /^author /{
 511                s/'\''/'\''\\'\'\''/g
 512                h
 513                s/^author \([^<]*\) <[^>]*> .*$/\1/
 514                s/'\''/'\''\'\'\''/g
 515                s/.*/GIT_AUTHOR_NAME='\''&'\''/p
 516
 517                g
 518                s/^author [^<]* <\([^>]*\)> .*$/\1/
 519                s/'\''/'\''\'\'\''/g
 520                s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
 521
 522                g
 523                s/^author [^<]* <[^>]*> \(.*\)$/\1/
 524                s/'\''/'\''\'\'\''/g
 525                s/.*/GIT_AUTHOR_DATE='\''&'\''/p
 526
 527                q
 528        }
 529        '
 530        set_author_env=`git-cat-file commit "$use_commit" |
 531        LANG=C LC_ALL=C sed -ne "$pick_author_script"`
 532        eval "$set_author_env"
 533        export GIT_AUTHOR_NAME
 534        export GIT_AUTHOR_EMAIL
 535        export GIT_AUTHOR_DATE
 536fi
 537
 538PARENTS="-p HEAD"
 539if test -z "$initial_commit"
 540then
 541        rloga='commit'
 542        if [ -f "$GIT_DIR/MERGE_HEAD" ]; then
 543                rloga='commit (merge)'
 544                PARENTS="-p HEAD "`sed -e 's/^/-p /' "$GIT_DIR/MERGE_HEAD"`
 545        elif test -n "$amend"; then
 546                rloga='commit (amend)'
 547                PARENTS=$(git-cat-file commit HEAD |
 548                        sed -n -e '/^$/q' -e 's/^parent /-p /p')
 549        fi
 550        current="$(git-rev-parse --verify HEAD)"
 551else
 552        if [ -z "$(git-ls-files)" ]; then
 553                echo >&2 Nothing to commit
 554                exit 1
 555        fi
 556        PARENTS=""
 557        rloga='commit (initial)'
 558        current=''
 559fi
 560
 561if test -z "$no_edit"
 562then
 563        {
 564                echo ""
 565                echo "# Please enter the commit message for your changes."
 566                echo "# (Comment lines starting with '#' will not be included)"
 567                test -z "$only_include_assumed" || echo "$only_include_assumed"
 568                run_status
 569        } >>"$GIT_DIR"/COMMIT_EDITMSG
 570else
 571        # we need to check if there is anything to commit
 572        run_status >/dev/null 
 573fi
 574if [ "$?" != "0" -a ! -f "$GIT_DIR/MERGE_HEAD" -a -z "$amend" ]
 575then
 576        rm -f "$GIT_DIR/COMMIT_EDITMSG" "$GIT_DIR/SQUASH_MSG"
 577        run_status
 578        exit 1
 579fi
 580
 581case "$no_edit" in
 582'')
 583        case "${VISUAL:-$EDITOR},$TERM" in
 584        ,dumb)
 585                echo >&2 "Terminal is dumb but no VISUAL nor EDITOR defined."
 586                echo >&2 "Please supply the commit log message using either"
 587                echo >&2 "-m or -F option.  A boilerplate log message has"
 588                echo >&2 "been prepared in $GIT_DIR/COMMIT_EDITMSG"
 589                exit 1
 590                ;;
 591        esac
 592        git-var GIT_AUTHOR_IDENT > /dev/null  || die
 593        git-var GIT_COMMITTER_IDENT > /dev/null  || die
 594        ${VISUAL:-${EDITOR:-vi}} "$GIT_DIR/COMMIT_EDITMSG"
 595        ;;
 596esac
 597
 598case "$verify" in
 599t)
 600        if test -x "$GIT_DIR"/hooks/commit-msg
 601        then
 602                "$GIT_DIR"/hooks/commit-msg "$GIT_DIR"/COMMIT_EDITMSG || exit
 603        fi
 604esac
 605
 606if test -z "$no_edit"
 607then
 608    sed -e '
 609        /^diff --git a\/.*/{
 610            s///
 611            q
 612        }
 613        /^#/d
 614    ' "$GIT_DIR"/COMMIT_EDITMSG
 615else
 616    cat "$GIT_DIR"/COMMIT_EDITMSG
 617fi |
 618git-stripspace >"$GIT_DIR"/COMMIT_MSG
 619
 620if cnt=`grep -v -i '^Signed-off-by' "$GIT_DIR"/COMMIT_MSG |
 621        git-stripspace |
 622        wc -l` &&
 623   test 0 -lt $cnt
 624then
 625        if test -z "$TMP_INDEX"
 626        then
 627                tree=$(GIT_INDEX_FILE="$USE_INDEX" git-write-tree)
 628        else
 629                tree=$(GIT_INDEX_FILE="$TMP_INDEX" git-write-tree) &&
 630                rm -f "$TMP_INDEX"
 631        fi &&
 632        commit=$(cat "$GIT_DIR"/COMMIT_MSG | git-commit-tree $tree $PARENTS) &&
 633        rlogm=$(sed -e 1q "$GIT_DIR"/COMMIT_MSG) &&
 634        git-update-ref -m "$rloga: $rlogm" HEAD $commit "$current" &&
 635        rm -f -- "$GIT_DIR/MERGE_HEAD" "$GIT_DIR/MERGE_MSG" &&
 636        if test -f "$NEXT_INDEX"
 637        then
 638                mv "$NEXT_INDEX" "$THIS_INDEX"
 639        else
 640                : ;# happy
 641        fi
 642else
 643        echo >&2 "* no commit message?  aborting commit."
 644        false
 645fi
 646ret="$?"
 647rm -f "$GIT_DIR/COMMIT_MSG" "$GIT_DIR/COMMIT_EDITMSG" "$GIT_DIR/SQUASH_MSG"
 648if test -d "$GIT_DIR/rr-cache"
 649then
 650        git-rerere
 651fi
 652
 653if test -x "$GIT_DIR"/hooks/post-commit && test "$ret" = 0
 654then
 655        "$GIT_DIR"/hooks/post-commit
 656fi
 657exit "$ret"